# Aufgabe 44: Arbeit mit der Gleitkommaeinheit
#
# von: Stephan Brumme
#
# zuletzt geaendert: 22.Juni 2000

	.data
request_number:	.asciiz "Bitte geben Sie die natuerliche Zahl ein, aus der die Quadratwurzel berechnet werden soll: "
result_part1:	.asciiz "\nDas Programm hat die Wurzel von "
result_part2:	.asciiz " in "
result_part3:	.asciiz " Iterationen berechnet. Die Wurzel von "
result_part4:	.asciiz " ist "
result_part5:	.asciiz ".\n"
error:		.asciiz "Die Wurzel kann nur von positiven Zahlen berechnet werden !\n"
einhalb:	.double 0.5
null:		.double 0.0

	.text 0x400000
main:
	li	$v0,4			# Eingabeaufforderung
	la	$a0,request_number
	syscall

	li 	$v0,5			# Integerzahl einlesen
	syscall

	blez	$v0,negativ_error	# nur Zahlen >0 sind erlaubt

# ############################################################################
# Registerbelegung (Variablenbezeichnungen gemaess Aufgabenstellung:
#
#     Integer:
#       $s0   -   n (Zahl, aus der die Wurzel gezogen wird)
#	$s1   -   Anzahl Iterationen
#
#     Double:
#       $f2/$f3 - n
#	$f4/$f5 - wurzel_alt
#	$f6/$f7 - wurzel_neu
#	$f8/$f9 - differenz
#	$f20/$f21, $f22/$f23 - Hilfsregister

	mtc1	$v0,$f2			# n in den Coprozessor kopieren
	cvt.d.w	$f2,$f2			# die Integerzahl in Double umwandeln
	
	move	$s0,$v0			# n fuer spaetere Ausgabe aufbewahren
	li	$s1,0			# Anzahl Iterationen feststellen

	l.d	$f20,einhalb		# Hilfsvariable laden (Konstante 0,5)
	l.d	$f22,null		# Hilfsvariable laden (Konstante 0,0)
	mov.d	$f4,$f2			# wurzel_alt=n
iteration:
	div.d	$f6,$f2,$f4		# wurzel_neu := n/wurzel_alt
	add.d	$f6,$f4,$f6		# wurzel_neu := wurzel_alt+n/wurzel_alt
	mul.d	$f6,$f20,$f6		# wurzel_neu := 0,5*(wurzel_alt+n/wurzel_alt)

	sub.d	$f8,$f4,$f6		# differenz := wurzel_alt-wurzel_neu

	mov.d	$f4,$f6			# wurzel_alt := wurzel_neu

	addi	$s1,$s1,1		# Anzahl Iterationen um 1 erhoehen

	c.le.d	$f8,$f22		# ist Differenz <=0 ?
	bc1f	iteration		# wenn nicht, dann naechste Iteration

# Ende Wurzelberechnung
# ############################################################################

	li	$v0,4			# 1.Text-Teil der Ausgabe
	la	$a0,result_part1
	syscall

	li	$v0,1			# n als Integer ausgeben
	move	$a0,$s0
	syscall
	
	li	$v0,4			# 2.Text-Teil der Ausgabe
	la	$a0,result_part2
	syscall

	li	$v0,1			# Anzahl Iterationen als Integer ausgeben
	move	$a0,$s1
	syscall
	
	li	$v0,4			# 3.Text-Teil der Ausgabe
	la	$a0,result_part3
	syscall

	li	$v0,1			# n als Integer ausgeben
	move	$a0,$s0
	syscall
	
	li	$v0,4			# 4.Text-Teil der Ausgabe
	la	$a0,result_part4
	syscall

	li	$v0,3			# Wurzel von n als Double ausgeben
	mov.d	$f12,$f6
	syscall
	
	li	$v0,4			# 5.Text-Teil der Ausgabe
	la	$a0,result_part5
	syscall

	li	$v0,10			# Programm beenden
	syscall

negativ_error:
	li	$v0,4			# Fehlermeldung bei nicht-positiver eingegebener Zahl
	la	$a0,error
	syscall	

	li	$v0,10			# Programm beenden
	syscall